; MC_Chapterfy: 160815
; Author: jmone Thread on Interact: http://yabb.jriver.com/interact/index.php?topic=100436.0
; Inspired by MrC

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#SingleInstance ignore
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

;============= Set Vars and Check Runtime Mode ===========================
IniRead, MC_WS, MC_Chapterfy.ini,MC_Settings,MC_WS
IniRead, MC_UserName, MC_Chapterfy.ini,MC_Settings,MC_UserName
IniRead, MC_Password, MC_Chapterfy.ini,MC_Settings,MC_Password
FileDelete, temp.chapters.txt

;============= Initialise and Setup Menu===========================
if !FileExist("MC_Chapterfy.ini")
  {
  Gui, Add, Text,x10 y10,Setup Chapterfy and Configure for the First Time:
  Gui, Add, Edit, x40 y30 w130 h20 vMC_Ver, 22
  Gui, Add, Text,x180 y30,<--- Enter the Version of MC (eg 20, 21, 22 etc)
  Gui, Add, Edit, x40 y60 w130 h20 vMC_WS, 127.0.0.1:52199
  Gui, Add, Text,x180 y60,<--- Enter MCWS Server Address:Port
  Gui, Add, Edit, x40 y90 w130 h20 vMC_UserName, username
  Gui, Add, Text,x180 y90,<--- Enter MCWS Username
  Gui, Add, Edit, x40 y120 w130 h20 vMC_Password, password
  Gui, Add, Text,x180 y120,<--- Enter MCWS Password
  Gui, Add, Button, x40 y150 w130 h20, Test
  gui, add, text, x10 y180 w400 0x10
  Gui, Add, Button, x40 y190 w130 h20, Save
  Gui, Add, Button, x250 y190 w130 h20, Cancel
  Gui, Show,,MC Chapterfy Installer
  Return
;---------- CheckMC and User Settings ----------------
  ButtonTest:
    Gui, Submit, NoHide
    guiControlGet, UserInput
    Progress, b1 w300, Checking for Media Center at %MC_WS%`n Please Wait
    sleep, 1000
    MC_Call = http://%MC_WS%/MCWS/v1/Authenticate
    GoSub, MCWS
    Progress, off
    If Status = 200 
      MsgBox, All OK!
  Return
;---------- Make INI and Registry Changes ----------------
  ButtonSave:
    Gui, Submit, NoHide
    guiControlGet, UserInput
    IniWrite, %MC_WS%, MC_Chapterfy.ini,MC_Settings,MC_WS
    IniWrite, %MC_UserName%, MC_Chapterfy.ini,MC_Settings,MC_UserName
    IniWrite, %MC_Password%, MC_Chapterfy.ini,MC_Settings,MC_Password
    RegWrite, REG_SZ, HKEY_CURRENT_USER, SOFTWARE\J. River\Media Center %MC_Ver%\Properties\External Tools,Chapterfy,%A_ScriptDir%\MC_Chapterfy.exe||0
    RegWrite, REG_SZ, HKEY_CURRENT_USER, SOFTWARE\J. River\Media Center %MC_Ver%\Properties\External Tools,Chapterfy (Auto),%A_ScriptDir%\MC_Chapterfy.exe|Auto|0
    RegWrite, REG_SZ, HKEY_CURRENT_USER, SOFTWARE\J. River\Media Center %MC_Ver%\Properties\External Tools,Chapterfy (ReadChapterFile),%A_ScriptDir%\MC_Chapterfy.exe|ReadChapterFile|0
    RegWrite, REG_SZ, HKEY_CURRENT_USER, SOFTWARE\J. River\Media Center %MC_Ver%\Properties\External Tools,Chapterfy (CreateChapterFile),%A_ScriptDir%\MC_Chapterfy.exe|CreateChapterFile|0
    gosub, Script_End
  }
;=============  Chapterfy Run Time from MC ================================
InputVar = %1%
If InputVar
{
  If InputVar = Auto
    gosub, ButtonAuto
  If InputVar = ReadChapterFile
    gosub, ButtonReadChapterFile
  If InputVar = CreateChapterFile
    gosub, ButtonCreateChapterFile
}
;============= Main Menu ================================
Gui, Add, Text,x10, Create Chapter Particles : Select ONE item in MC to create Chapter Particles using one of the options Below:
Gui, Add, Button, x80 y30 w150 h25, Auto
Gui, Add, Text, x230 y35 w300 h25, <--- Get Chapter Information from ChapterDB
Gui, Add, Button, x80 y60 w150 h25, ReadMPLS
Gui, Add, Text, x230 y65 w300 h25, <--- Get Chapter Times (no names) from a Blu Ray Playlist (MPLS) File
Gui, Add, Button, x80 y90 w150 h25 v1, ReadChapterFile
Gui, Add, Text, x230 y95 w300 h25, <--- Select a Chapter.TXT (not XML) File
Gui, Add, Button, x80 y120 w150 h25, ChapterDB
Gui, Add, Text, x230 y125 w300 h25, <--- Enter Chapter DB # and Press Button
Gui, Add, Edit, x20 y122 w55 h20 vUserInput1
Gui, Add, Button, x80 y150 w150 h25, Manual
Gui, Add, Text, x230 y155 w300 h25, <--- Enter # of Chapters to Create and Press Button
Gui, Add, Edit, x50 y152 w25 h20 vUserInput2
gui, add, Text, x10 y180 w500 0x10
Gui, Add, Text,x10 y185, Bulk Create Particles : Select ONE or MORE items in MC to Bulk create Particles:
Gui, Add, Button, x80 y205 w150 h25, Bulk
Gui, Add, Text, x230 y210 w300 h25, <--- Enter # of Particles to Create and Press Button
Gui, Add, Edit, x50 y207 w25 h20 vUserInput3
gui, add, text, x10 y235 w500 0x10
Gui, Add, Text,x10 y242,Export Chatper Partices : Select ALL Chatpers in MC to create a CHAPTER.TXT File:
Gui, Add, Button, x80 y260 w150 h25, CreateChapterFile
Gui, Add, Button, x340 y300 w150 h25, Cancel
Gui, Show,,Chapterfy Menu

Return
;============= Process Choice =============
ButtonReadChapterFile:
  FileSelectFile, SelectedFile, 3, , Open a file
  GuiControl,,Select%A_GuiControl%,%SelectedFile%
  If (SelectedFile = "")
    Return
  FileCopy, %SelectedFile%, temp.chapters.txt
  Gui, Submit, Hide
  gosub, MC_Current
  gosub, Process_Chapters
gosub, Script_End

ButtonManual:
  Gui, Submit, Hide
  guiControlGet, UserInput
  Loop %UserInput2%
  {
  Chap_N = %A_Index%
  If A_Index < 10
    Chap_N = 0%A_Index%
  FileAppend, CHAPTER%Chap_N%=00:%Chap_N%:00.000`n, temp.chapters.txt
  FileAppend, CHAPTER%Chap_N%NAME=Chapter %Chap_N%`n, temp.chapters.txt
  }
  gosub, MC_Current
  gosub, Process_Chapters
gosub, Script_End

ButtonBulk:
  Gui, Submit, Hide
  guiControlGet, UserInput

  MC_Call = http://%MC_WS%/MCWS/v1/Files/Current?Action=Serialize
  GoSub, MCWS
  If Status !=200
    gosub, Script_End
  RegExMatch(result,"[^;]+$", MC_Key)
  If MC_Key < 0
    {
    msgbox, Nothing is Selected!
    gosub, Script_End
    }

  Loop, parse, Result, `;
    If A_Index > 3
    {
      MC_Call = http://%MC_WS%/MCWS/v1/File/CreateParticle?File=%A_LoopField%&FileType=Key&Count=%UserInput3%
      GoSub, MCWS
      If Status !=200
        gosub, Script_End
     }
gosub, Script_End

ButtonChapterDB:
  Gui, Submit, Hide
  guiControlGet, UserInput
  CDB_ID = %UserInput1%
  urldownloadtofile, http://www.chapterdb.org/Home/Download/%CDB_ID%?type=txt, temp.chapters.txt
  gosub, MC_Current
  gosub, Process_Chapters
gosub, Script_End

ButtonAuto:
  Gui, Submit, Hide
  guiControlGet, UserInput
  gosub, MC_Current
  gosub, MC_GetInfo
  If Status !=200
    gosub, Script_End
  If MC_FileExt = mpls ;or MC_FileType = MPLS
    {
    Progress, b1 w300, Checking for Chatper Info Please Wait
    hash = % MD5(MC_FilenameExt)
    CDB_Call = http://www.chapterdb.org/chapters/disc-%hash%
    GoSub, CDB_API
    If Status = 200 
      {
      urldownloadtofile, http://www.chapterdb.org/Home/Download/%CDB_ID%?type=txt, temp.chapters.txt
      AddMsg = Chapter Information found at http://www.chapterdb.org/Home/Download/%CDB_ID%
      Progress, off
      gosub, Process_Chapters
      }
    Else
      {
      msgbox, Error - %Status%  Processed Failed (see details below)`n`n%Result%
      MsgBox, 4,, Would you like to Read the Chatper Times Directly from the MPLS (you will need to add your own Chapter Names)?
      IfMsgBox Yes
        gosub, ButtonReadMPLS
      }
    }
  Else
    msgbox, %MC_FilenameExt% is not a Bluray Playlist (*.mpls) file!
gosub, Script_End

ButtonReadMPLS:
  Gui, Submit, Hide
  guiControlGet, UserInput
  gosub, MC_Current
  gosub, MC_GetInfo
  If Status !=200
    gosub, Script_End
  If MC_FileExt = mpls ;or MC_FileType = MPLS
    {
    Progress, b1 w300, Checking for Chatper Info Please Wait
    ;-------Open File and Read as HEX to Var Hexfile-----
    gosub, FileToHex

    ;-------Parse Main Section of MPLS------------------- 
    PlaylistSectionA := % hexToDecimal(SubStr(Hexfile,17,8)) ; Location of the Playlist Section
    PlaylistMarkSectionA:= % hexToDecimal(SubStr(Hexfile,25,8)) ; Location of the Playlist MarkSection 

    ;-------Parse Playlist Section ---------------------- 
    PlaylistSectionA := PlaylistSectionA*2+1
    TempHex := SubStr(HexFile,PlaylistSectionA+12,4)
    NumberofPlayItems := % hexToDecimal(TempHex) ; Get number of Playlist Items

    ;-------Loop PlayItem in Playlist Section------------
    PlayItemA := PlaylistSectionA+20
    Loop, %NumberofPlayItems%
      {
      TempHex := SubStr(HexFile,PlayItemA,4)
      PlayItemLength := % hexToDecimal(TempHex)

      TempHex := SubStr(HexFile,PlayItemA+28,8)
      Temp := % hexToDecimal(TempHex)
      TempSec := Temp/45000
      PlayItemInSec%A_Index% := TempSec ; Get each PlayItem's Time In Value

      TempHex := SubStr(HexFile,PlayItemA+36,8)
      Temp := % hexToDecimal(TempHex)
      TempSec := Temp/45000 
      PlayItemOutSec%A_Index% := TempSec ; Get each PlayItem's Time Out Value

      PlayItemA := PlayItemA+PlayItemLength*2+4
      }

    ;-------Parse Playlist Mark Section -------------------- 
    PlaylistMarkSectionA := PlaylistMarkSectionA*2+1
    TempHex := SubStr(HexFile,PlaylistMarkSectionA+8,4)
    NumberofPlaylistMarks := % hexToDecimal(TempHex) ; Get Number of Play List Marks (Chatpers)

    ;-------Parse Playlist Mark Entry and Write File--------- 
    PlaylistMarkSectionEntryA := PlaylistMarkSectionA+12
    CumPlayItemLength=0 
    Loop, %NumberofPlaylistMarks%
      {
      TempHex := SubStr(HexFile,PlaylistMarkSectionEntryA+4,4)
      PlayItemID := % hexToDecimal(TempHex)

      TempHex := SubStr(HexFile,PlaylistMarkSectionEntryA+8,8)
      Temp := % hexToDecimal(TempHex)
      TempSec := Temp/45000 
      temp := PlayItemID+1 ; increment PlayItemID to match PlayItemInSec that start at 0 instead of 1

      If (PlayItemID != OldPlayItemID)
        {
        PlayItemLength := PlayItemOutSec%temp%-PlayItemInSec%temp%
        CumPlayItemLength := PlayItemLength+CumPlayItemLength
        }

      ChapStartTime :=TempSec-PlayItemInSec%temp%+CumPlayItemLength-PlayItemLength
      ChapStartTime = % SecToChapTime(ChapStartTime)
      Chap_N = %A_Index%

    ; --------- Write details to file
      If A_Index < 10
        Chap_N = 0%A_Index%
      FileAppend, CHAPTER%Chap_N%=%ChapStartTime%`n, temp.chapters.txt 
      FileAppend, CHAPTER%Chap_N%NAME=Chapter %Chap_N%`n, temp.chapters.txt

      OldPlayItemID := PlayItemID
      PlaylistMarkSectionEntryA := PlaylistMarkSectionEntryA+28
      }
    progress, off
    gosub, Process_Chapters
    }
  Else
    msgbox, %MC_FilenameExt% is not a Bluray Playlist (*.mpls) file!
gosub, Script_End

ButtonCreateChapterFile:
  GoSub, MC_Current
  If MC_Chapters0 < 1
    {
    msgbox, Nothing is Selected!
    gosub, Script_End
    }
  Progress, b1 w300, Creating Chapter File Please Wait
  Loop, %MC_Chapters0%
  {
    MC_Key := MC_Chapters%A_Index%
    GoSub, MC_GetInfo
    StringReplace, MC_Name, MC_Name, &amp;, &

    ChapFilename=%MC_Filename%.chapters.txt
    Chap_N = %A_Index%
    If A_Index < 10
      Chap_N = 0%A_Index%
    FileAppend, CHAPTER%Chap_N%=%MC_Start%`n, %ChapFilename%
    FileAppend, CHAPTER%Chap_N%NAME=%MC_Name%`n, %ChapFilename%
  }
gosub, Script_End

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++ FUNCTIONS and SUBS ++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;------------ Chapterise from Chatper.TXT File --------------------
Process_Chapters:
MsgBox, On the next screen you can review and edit the Chapter File if needed.  When finished just Close Notepad (saving any changes) and you will then be asked if you want to Chapterfy based on this file.`n`n%AddMsg%
RunWait, %comspec% /c notepad.exe temp.chapters.txt,, Hide
MsgBox, 4,, Would you like to now Chapterfy:`n`n %MC_Name%
IfMsgBox No
    gosub, Script_End

progress, b1 w300, Creating Chapters Please Wait
Loop, read, temp.chapters.txt
    last_line++

Last_Chap:=last_line-2
File_Line:=1
Loop
{
  If File_Line > %last_line%
    Break

  L_Progress := File_Line/last_line*100
  Progress, %L_Progress%

  ;------------- Create Chapter Particles ----------------

  MC_Call = http://%MC_WS%/MCWS/v1/File/CreateParticle?File=%MC_Key%&FileType=Key&Count=1
  GoSub, MCWS
  If Status !=200
    gosub, Script_End
  RegExMatch(Result,"(?<=Keys"">)(.*)(?=</Item>)", MCParticle_Key)

  ;------------ Update Chapter Particles ----------------

  FileReadLine, Chapter_Start, temp.chapters.txt, File_Line
  FileReadLine, Chapter_Name, temp.chapters.txt, File_Line+1
  FileReadLine, Chapter_Finish, temp.chapters.txt, File_Line+2

  If File_Line > %last_line%
    Break

  StringTrimLeft, MC_Name, Chapter_Name, 14
  MC_Name = % UrlEncode(MC_Name)

  StringTrimLeft, Chapter_Start, Chapter_Start, 10
  StringTrimLeft, Chapter_Finish, Chapter_Finish, 10
  MC_PlaybackRange = %Chapter_Start%-%Chapter_Finish%
  If File_Line > %Last_Chap%
     MC_PlaybackRange = %Chapter_Start%-

  MC_Call = http://%MC_WS%/MCWS/v1/File/SetInfo?File=%MCParticle_Key%&FileType=Key&Field=Name,Playback Range, Track #&Value=%MC_Name%,%MC_PlaybackRange%,%A_Index%&List=CSV

  GoSub, MCWS
  If Status !=200
    gosub, Script_End

  File_Line:=File_Line+2
}

Return
;------------ MC Get Current Item Key(s)-----------------
MC_Current:
  MC_Call = http://%MC_WS%/MCWS/v1/Files/Current?Action=Serialize
  GoSub, MCWS
  If Status !=200
    gosub, Script_End
  RegExMatch(result,"[^;]+$", MC_Key)
  If MC_Key < 0
    {
    msgbox, Nothing is Selected!
    gosub, Script_End
    }
  RegExMatch(Result,"(?<=-1;)(.*)", Result)
;  RegExMatch(Result,"(?<=-1;)(?=</Field>)", Result)
  StringSplit, MC_Chapters, Result, ';
Return
;------------ MC Get Details with an Key-----------------
MC_GetInfo:
  MC_Call = http://%MC_WS%/MCWS/v1/File/GetInfo?File=%MC_Key%&Fields=Name,Playback Range,Filename,File Type
  GoSub, MCWS
  RegExMatch(Result,"(?<=Name"">)(.*)(?=</Field>)", MC_Name)
  RegExMatch(Result,"(?<=Range"">)(.*)(?=-)", MC_Start)
  RegExMatch(Result,"(?<=Filename"">)(.*)(?=[.])", MC_Filename)
  RegExMatch(Result,"(?<=Filename"">)(.*)(?=</Field>)", MC_FilenameExt)
  RegExMatch(Result,"(?<=Type"">)(.*)(?=</Field>)", MC_FileType)
  StringTrimLeft, MC_FileExt, MC_FilenameExt, StrLen(MC_Filename)+1
Return
;-------------MCWS---------------------------
MCWS:
  WinHTTP := ComObjCreate("WinHTTP.WinHttpRequest.5.1")
  ComObjError(false)
  WinHTTP.Open("GET", MC_Call)
  WinHTTP.SetCredentials(MC_UserName,MC_Password,0)
  WinHTTP.SetRequestHeader("Content-type", "application/x-www-form-urlencoded")
  Body = ""
  WinHTTP.Send(Body)
  Result := WinHTTP.ResponseText
  Status := WinHTTP.Status
  If Status = 200 
    Return
  Else 
    {
    Progress, off
    If !Status
      msgbox, Error - MediaCenter not Found at %MC_WS%
    Else
      If Status = 401
        msgbox, Error 401 Access Denied - Check Username / Password
      Else
        msgbox, Error - %Status%  Processed Failed (see details below)`n%MC_Call%`n%Result%
    }
Return
;--------------ChapterDB API Call-------------------------
CDB_API:
  WinHTTP := ComObjCreate("WinHTTP.WinHttpRequest.5.1")
  ComObjError(false)
  WinHTTP.Open("GET",CDB_Call)
  WinHTTP.SetRequestHeader("ApiKey","IVB32FJYYTFQDP5UQ1A7")
  Body = ""
  Progress, 25
  WinHTTP.Send(Body)
  Result := WinHTTP.ResponseText
  Status := WinHTTP.Status
  Progress, Off
  RegExMatch(Result,"(?<=chapterSetId>)(.*)(?=</chapterSetId>)", CDB_ID)
Return
;-------------------MD5 Hash Calculator------------------
; Thanks to users at - http://www.autohotkey.com/board/topic/95502-getting-md5-hash-works-in-ansi-but-fails-with-unicode/#entry601707
MD5(ByRef MD5Filepath)
{
  FileGetSize, MD5Size, %MD5Filepath%
  If !MD5Size
    {
    msgbox, Error - The File is Empty or Does Not Exist`n%MD5Filepath%
    gosub, Script_End
    }
  FileRead MD5Data, *c %MD5Filepath%
  VarSetCapacity(MD5_CTX, 104)
  DllCall("advapi32\MD5Init",  "Ptr", &MD5_CTX)
  DllCall("advapi32\MD5Update","Ptr", &MD5_CTX, "Str", MD5Data, "UInt", MD5Size)
  DllCall("advapi32\MD5Final", "Ptr", &MD5_CTX)
  VarSetCapacity(Hash, Size := 64 * (A_IsUnicode ? 2 : 1))
  DllCall("Crypt32.dll\CryptBinaryToString"
        , "Ptr", &MD5_CTX+88
        , "UInt", 16
        , "UInt", 4
        , "Str", Hash
        , "UIntP", Size
        , "CDECL UInt")
  StringUpper Hash, Hash
  return  RegExReplace(Hash,"[^A-F0-9]")
}

;------------------ Change Sec to Chapter Time ---------
SecToChapTime(decsec) 
{
  hrs := floor(decsec/60/60)
  if hrs < 10
    hrs = 0%hrs%
  min := floor(decsec/60 - hrs*60)
  if min < 10
    min = 0%min%
  sec := decsec - hrs*60*60 - min*60
  if sec < 10
    sec = 0%sec%
  StringLeft, sec, sec, 6
  Return Hrs ":" Min ":" Sec
}

; -----------Hex2Text(Hex)-----------------------------------------------------------------------------------------------------------
; Thanks to users at - http://www.autohotkey.com/board/topic/76561-ascii-to-hex-to-ascii-again-unicode/
Hex2Text(Hex) {
	startpos:=1
	Loop % StrLen(Hex)/2
		{
		n .= Chr( "0x" . SubStr(Hex, StartPos+2 , 2) . SubStr(Hex, StartPos , 2) )
		startpos +=4
		}
	Return n
	}

; ----------URL Encode -------------------------------------------------------------------------------------------------------------
; Thanks to users at - http://www.autohotkey.com/board/topic/35660-url-encoding-function/#entry224694
UrlEncode( String )
{
	OldFormat := A_FormatInteger
	SetFormat, Integer, H

	Loop, Parse, String
	{
		if A_LoopField is alnum
		{
			Out .= A_LoopField
			continue
		}
		Hex := SubStr( Asc( A_LoopField ), 3 )
		Out .= "%" . ( StrLen( Hex ) = 1 ? "0" . Hex : Hex )
	}

	SetFormat, Integer, %OldFormat%
        Out = "%Out%"
	return Out
}


; -----------hexToDecimal-----------------------------------------------------------------------------------------------------------
; Thanks to users at - http://www.autohotkey.com/board/topic/95502-getting-md5-hash-works-in-ansi-but-fails-with-unicode/#entry601707
hexToDecimal(str){
    static _0:=0,_1:=1,_2:=2,_3:=3,_4:=4,_5:=5,_6:=6,_7:=7,_8:=8,_9:=9,_a:=10,_b:=11,_c:=12,_d:=13,_e:=14,_f:=15
    str:=ltrim(str,"0x `t`n`r"),   len := StrLen(str),  ret:=0
    Loop,Parse,str
      ret += _%A_LoopField%*(16**(len-A_Index))
    return ret
}

; ----------------------------------------------------------------------------------------------------------------------
; Name .........: FileToHex
; Description ..: Get the hexadecimal code of a file. Use this with the Windows "Send To" feature.
; AHK Version ..: AHK_L x32/64 Unicode
; Author .......: Cyruz - http://ciroprincipe.info
; License ......: WTFPL - http://www.wtfpl.net/txt/copying/
; Changelog ....: Dic. 31, 2013 - v0.1 - AHK_L version.
; ..............: Jan. 04, 2014 - v0.2 - Little adjustment to CryptBinToHex. Use it as default.
; ----------------------------------------------------------------------------------------------------------------------
FileToHex:
;  N_SPLIT := 112 ; Adjust this to split every X chars. If = 0 split will not occur.
  FileRead, cBuf, *C %MC_FilenameExt%
  ; Transform its content in Hexadecimal. CryptBinToHex is the fastest function of the two.
  ; It will be used if present in the system, otherwise we fall back to ToHex.
  (FileExist(A_WinDir "\System32\Crypt32.dll")) ? CryptBinToHex(sHex, cBuf) : ToHex(sHex, cBuf)
  ; Insert a newline every X char.
  If ( N_SPLIT ) {
      sSplitHex := RegExReplace(sHex, "iS)(.{" N_SPLIT "})", "$1`n")
      StringTrimRight, sSplitHex, sSplitHex, 1 ; Remove last `n.
      }
  HexFile := (N_SPLIT) ? sSplitHex : sHex
  Return 

  ; Thanks to Laszlo: http://www.autohotkey.com/forum/viewtopic.php?p=131700#131700.
  ToHex(ByRef sHex, ByRef cBuf, nSz:=-1) {
    nBz := VarSetCapacity(cBuf)
    adr := &cBuf
    f := A_FormatInteger
    SetFormat, Integer, Hex
    Loop % nSz < 0 ? nBz : nSz
        sHex .= *adr++
    SetFormat, Integer, %f%
    sHex := RegExReplace(sHex, "S)x(?=.0x|.$)|0x(?=..0x|..$)")
  }
 
  ; Thanks to nnnik: http://ahkscript.org/boards/viewtopic.php?f=6&t=1242#p8376.
  CryptBinToHex(ByRef sHex, ByRef cBuf) {
    szBuf := VarSetCapacity(cBuf)
    DllCall( "Crypt32.dll\CryptBinaryToString", Ptr,&cBuf, UInt,szBuf, UInt,4, Ptr,0, UIntP,szHex )
    VarSetCapacity(cHex, szHex*2, 0)
    DllCall( "Crypt32.dll\CryptBinaryToString", Ptr,&cBuf, UInt,szBuf, UInt,4, Ptr,&cHex, UIntP,szHex )
    sHex := RegExReplace(StrGet(&cHex, szHex, "UTF-16"), "S)\s")
  }
 
;=================== APP END ACTIONS ==========================
ButtonCancel:
GuiClose:
GuiEscape:
Script_End:
Gui, Hide
FileDelete, temp.chapters.txt
Progress, Off
;msgbox Finished
exitapp





